
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Collector.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Collector::packageName  = string ("com.redhat.grid");
string  Collector::className    = string ("collector");
uint8_t Collector::md5Sum[MD5_LEN]   =
    {0x7d,0xc5,0x2a,0x5,0xb0,0xcc,0xa,0xa,0x18,0x1c,0xe8,0xb,0x78,0x68,0x26,0x54};

Collector::Collector (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    Pool = "";
    System = "";
    Name = "";
    MyAddress = "";
    RunningJobs = 0;
    IdleJobs = 0;
    HostsTotal = 0;
    HostsClaimed = 0;
    HostsUnclaimed = 0;
    HostsOwner = 0;



}

Collector::~Collector ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Collector::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Collector::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (7); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "CondorPlatform";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor platform string for the daemon's platform";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "CondorVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor version string for the daemon's version";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "DaemonStartTime";
    ft[TYPE] = TYPE_ABSTIME;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "nanosecond";
    ft[DESC] = "Number of nanoseconds since epoch when the daemon     was started";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Pool";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "System";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MyAddress";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "RunningJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "IdleJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "HostsTotal";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "HostsClaimed";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "HostsUnclaimed";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "HostsOwner";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);


    // Methods

    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Collector::getKey() const
{
    std::stringstream key;

    key << Pool << ",";
    key << System << ",";
    key << Name;
    return key.str();
}



void Collector::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["CondorPlatform"] = ::qpid::types::Variant(CondorPlatform);
    _map["CondorVersion"] = ::qpid::types::Variant(CondorVersion);
    _map["DaemonStartTime"] = ::qpid::types::Variant(DaemonStartTime);
    _map["Pool"] = ::qpid::types::Variant(Pool);
    _map["System"] = ::qpid::types::Variant(System);
    _map["Name"] = ::qpid::types::Variant(Name);
    _map["MyAddress"] = ::qpid::types::Variant(MyAddress);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["RunningJobs"] = ::qpid::types::Variant(RunningJobs);
    _map["IdleJobs"] = ::qpid::types::Variant(IdleJobs);
    _map["HostsTotal"] = ::qpid::types::Variant(HostsTotal);
    _map["HostsClaimed"] = ::qpid::types::Variant(HostsClaimed);
    _map["HostsUnclaimed"] = ::qpid::types::Variant(HostsUnclaimed);
    _map["HostsOwner"] = ::qpid::types::Variant(HostsOwner);


    // Maintenance of hi-lo statistics


    }
}

void Collector::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("CondorPlatform")) != _map.end()) {
        CondorPlatform = (_i->second).getString();
    }
    if ((_i = _map.find("CondorVersion")) != _map.end()) {
        CondorVersion = (_i->second).getString();
    }
    if ((_i = _map.find("DaemonStartTime")) != _map.end()) {
        DaemonStartTime = _i->second;
    }
    if ((_i = _map.find("Pool")) != _map.end()) {
        Pool = (_i->second).getString();
    }
    if ((_i = _map.find("System")) != _map.end()) {
        System = (_i->second).getString();
    }
    if ((_i = _map.find("Name")) != _map.end()) {
        Name = (_i->second).getString();
    }
    if ((_i = _map.find("MyAddress")) != _map.end()) {
        MyAddress = (_i->second).getString();
    }

}

void Collector::doMethod (string&, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
