
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Negotiator.h"
#include "ArgsGridMethodsEcho.h"
#include "ArgsNegotiatorGetLimits.h"
#include "ArgsNegotiatorSetLimit.h"
#include "ArgsNegotiatorGetStats.h"
#include "ArgsNegotiatorSetPriority.h"
#include "ArgsNegotiatorSetPriorityFactor.h"
#include "ArgsNegotiatorSetUsage.h"
#include "ArgsNegotiatorGetRawConfig.h"
#include "ArgsNegotiatorSetRawConfig.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Negotiator::packageName  = string ("com.redhat.grid");
string  Negotiator::className    = string ("negotiator");
uint8_t Negotiator::md5Sum[MD5_LEN]   =
    {0x72,0x4d,0x61,0x59,0x59,0x3c,0xd7,0x27,0x7e,0x1,0x44,0x13,0x55,0xcb,0xb6,0xef};

Negotiator::Negotiator (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    Pool = "";
    System = "";
    Name = "";
    Machine = "";
    MyAddress = "";
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;



}

Negotiator::~Negotiator ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Negotiator::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Negotiator::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (8); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (10); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "Pool";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "System";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Machine";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MyAddress";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "CondorPlatform";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor platform string for the daemon's platform";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "CondorVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor version string for the daemon's version";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "DaemonStartTime";
    ft[TYPE] = TYPE_ABSTIME;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "nanosecond";
    ft[DESC] = "Number of nanoseconds since epoch when the daemon     was started";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "MonitorSelfAge";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfCPUUsage";
    ft[TYPE] = TYPE_DOUBLE;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfImageSize";
    ft[TYPE] = TYPE_DOUBLE;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfRegisteredSocketCount";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfResidentSetSize";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfTime";
    ft[TYPE] = TYPE_ABSTIME;
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "echo";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sequence";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "body";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetLimits";
    ft[ARGCOUNT] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Limits";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetLimit";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Max";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetStats";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "User or group name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Ad";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetPriority";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "User or group name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Priority";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetPriorityFactor";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "User or group name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "PriorityFactor";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetUsage";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "User or group name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Usage";
    ft[TYPE] = TYPE_DOUBLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetRawConfig";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Config param name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Value";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetRawConfig";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Config param name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Value";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "Reconfig";
    ft[ARGCOUNT] = 0;
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Negotiator::getKey() const
{
    std::stringstream key;

    key << Pool << ",";
    key << System << ",";
    key << Name;
    return key.str();
}



void Negotiator::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["Pool"] = ::qpid::types::Variant(Pool);
    _map["System"] = ::qpid::types::Variant(System);
    _map["Name"] = ::qpid::types::Variant(Name);
    _map["Machine"] = ::qpid::types::Variant(Machine);
    _map["MyAddress"] = ::qpid::types::Variant(MyAddress);
    _map["CondorPlatform"] = ::qpid::types::Variant(CondorPlatform);
    _map["CondorVersion"] = ::qpid::types::Variant(CondorVersion);
    _map["DaemonStartTime"] = ::qpid::types::Variant(DaemonStartTime);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["MonitorSelfAge"] = ::qpid::types::Variant(MonitorSelfAge);
    _map["MonitorSelfCPUUsage"] = ::qpid::types::Variant(MonitorSelfCPUUsage);
    _map["MonitorSelfImageSize"] = ::qpid::types::Variant(MonitorSelfImageSize);
    _map["MonitorSelfRegisteredSocketCount"] = ::qpid::types::Variant(MonitorSelfRegisteredSocketCount);
    _map["MonitorSelfResidentSetSize"] = ::qpid::types::Variant(MonitorSelfResidentSetSize);
    _map["MonitorSelfTime"] = ::qpid::types::Variant(MonitorSelfTime);


    // Maintenance of hi-lo statistics


    }
}

void Negotiator::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("Pool")) != _map.end()) {
        Pool = (_i->second).getString();
    }
    if ((_i = _map.find("System")) != _map.end()) {
        System = (_i->second).getString();
    }
    if ((_i = _map.find("Name")) != _map.end()) {
        Name = (_i->second).getString();
    }
    if ((_i = _map.find("Machine")) != _map.end()) {
        Machine = (_i->second).getString();
    }
    if ((_i = _map.find("MyAddress")) != _map.end()) {
        MyAddress = (_i->second).getString();
    }
    if ((_i = _map.find("CondorPlatform")) != _map.end()) {
        CondorPlatform = (_i->second).getString();
    }
    if ((_i = _map.find("CondorVersion")) != _map.end()) {
        CondorVersion = (_i->second).getString();
    }
    if ((_i = _map.find("DaemonStartTime")) != _map.end()) {
        DaemonStartTime = _i->second;
    }

}

void Negotiator::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "echo") {
        ArgsGridMethodsEcho ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("sequence")) != inMap.end()) {
            ioArgs.io_sequence = _i->second;
        }
        if ((_i = inMap.find("body")) != inMap.end()) {
            ioArgs.io_body = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_ECHO, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["sequence"] = ::qpid::types::Variant(ioArgs.io_sequence);
        outMap["body"] = ::qpid::types::Variant(ioArgs.io_body);
        return;
    }

    if (methodName == "GetLimits") {
        ArgsNegotiatorGetLimits ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        status = coreObject->ManagementMethod (METHOD_GETLIMITS, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Limits"] = ::qpid::types::Variant(ioArgs.o_Limits);
        return;
    }

    if (methodName == "SetLimit") {
        ArgsNegotiatorSetLimit ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("Max")) != inMap.end()) {
            ioArgs.i_Max = _i->second;
        }
        status = coreObject->ManagementMethod (METHOD_SETLIMIT, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "GetStats") {
        ArgsNegotiatorGetStats ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_GETSTATS, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Ad"] = ::qpid::types::Variant(ioArgs.o_Ad);
        return;
    }

    if (methodName == "SetPriority") {
        ArgsNegotiatorSetPriority ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("Priority")) != inMap.end()) {
            ioArgs.i_Priority = _i->second;
        }
        status = coreObject->ManagementMethod (METHOD_SETPRIORITY, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "SetPriorityFactor") {
        ArgsNegotiatorSetPriorityFactor ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("PriorityFactor")) != inMap.end()) {
            ioArgs.i_PriorityFactor = _i->second;
        }
        status = coreObject->ManagementMethod (METHOD_SETPRIORITYFACTOR, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "SetUsage") {
        ArgsNegotiatorSetUsage ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("Usage")) != inMap.end()) {
            ioArgs.i_Usage = _i->second;
        }
        status = coreObject->ManagementMethod (METHOD_SETUSAGE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "GetRawConfig") {
        ArgsNegotiatorGetRawConfig ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_GETRAWCONFIG, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Value"] = ::qpid::types::Variant(ioArgs.o_Value);
        return;
    }

    if (methodName == "SetRawConfig") {
        ArgsNegotiatorSetRawConfig ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("Value")) != inMap.end()) {
            ioArgs.i_Value = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_SETRAWCONFIG, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "Reconfig") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_RECONFIG, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
