
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Scheduler.h"
#include "ArgsGridMethodsEcho.h"
#include "ArgsSchedulerSubmitJob.h"
#include "ArgsSchedulerSetJobAttribute.h"
#include "ArgsSchedulerHoldJob.h"
#include "ArgsSchedulerReleaseJob.h"
#include "ArgsSchedulerRemoveJob.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Scheduler::packageName  = string ("com.redhat.grid");
string  Scheduler::className    = string ("scheduler");
uint8_t Scheduler::md5Sum[MD5_LEN]   =
    {0x81,0x21,0x9c,0xee,0xb5,0x4c,0x54,0xa6,0x1d,0xbd,0x26,0x6f,0x6b,0x9b,0x18,0x40};

Scheduler::Scheduler (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    Pool = "";
    System = "";
    JobQueueBirthdate = 0;
    MaxJobsRunning = 0;
    Machine = "";
    MyAddress = "";
    Name = "";
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;
    NumUsers = 0;
    TotalHeldJobs = 0;
    TotalIdleJobs = 0;
    TotalJobAds = 0;
    TotalRemovedJobs = 0;
    TotalRunningJobs = 0;



}

Scheduler::~Scheduler ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Scheduler::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Scheduler::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (10); // Config Element Count
    buf.putShort       (12); // Inst Element Count
    buf.putShort       (6); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "CondorPlatform";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor platform string for the daemon's platform";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "CondorVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor version string for the daemon's version";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "DaemonStartTime";
    ft[TYPE] = TYPE_ABSTIME;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "nanosecond";
    ft[DESC] = "Number of nanoseconds since epoch when the daemon     was started";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Pool";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "System";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "JobQueueBirthdate";
    ft[TYPE] = TYPE_ABSTIME;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MaxJobsRunning";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Machine";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MyAddress";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "MonitorSelfAge";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfCPUUsage";
    ft[TYPE] = TYPE_DOUBLE;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfImageSize";
    ft[TYPE] = TYPE_DOUBLE;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfRegisteredSocketCount";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfResidentSetSize";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfTime";
    ft[TYPE] = TYPE_ABSTIME;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "NumUsers";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TotalHeldJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TotalIdleJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TotalJobAds";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TotalRemovedJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TotalRunningJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "echo";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sequence";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "body";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SubmitJob";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Ad";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetJobAttribute";
    ft[ARGCOUNT] = 3;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Job's Id, the string ClusterId.ProcId";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Value";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "HoldJob";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Job's Id, the string ClusterId.ProcId";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Reason";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "ReleaseJob";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Job's Id, the string ClusterId.ProcId";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Reason";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "RemoveJob";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Job's Id, the string ClusterId.ProcId";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Reason";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Scheduler::getKey() const
{
    std::stringstream key;

    key << Pool << ",";
    key << System << ",";
    key << Name;
    return key.str();
}



void Scheduler::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["CondorPlatform"] = ::qpid::types::Variant(CondorPlatform);
    _map["CondorVersion"] = ::qpid::types::Variant(CondorVersion);
    _map["DaemonStartTime"] = ::qpid::types::Variant(DaemonStartTime);
    _map["Pool"] = ::qpid::types::Variant(Pool);
    _map["System"] = ::qpid::types::Variant(System);
    _map["JobQueueBirthdate"] = ::qpid::types::Variant(JobQueueBirthdate);
    _map["MaxJobsRunning"] = ::qpid::types::Variant(MaxJobsRunning);
    _map["Machine"] = ::qpid::types::Variant(Machine);
    _map["MyAddress"] = ::qpid::types::Variant(MyAddress);
    _map["Name"] = ::qpid::types::Variant(Name);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["MonitorSelfAge"] = ::qpid::types::Variant(MonitorSelfAge);
    _map["MonitorSelfCPUUsage"] = ::qpid::types::Variant(MonitorSelfCPUUsage);
    _map["MonitorSelfImageSize"] = ::qpid::types::Variant(MonitorSelfImageSize);
    _map["MonitorSelfRegisteredSocketCount"] = ::qpid::types::Variant(MonitorSelfRegisteredSocketCount);
    _map["MonitorSelfResidentSetSize"] = ::qpid::types::Variant(MonitorSelfResidentSetSize);
    _map["MonitorSelfTime"] = ::qpid::types::Variant(MonitorSelfTime);
    _map["NumUsers"] = ::qpid::types::Variant(NumUsers);
    _map["TotalHeldJobs"] = ::qpid::types::Variant(TotalHeldJobs);
    _map["TotalIdleJobs"] = ::qpid::types::Variant(TotalIdleJobs);
    _map["TotalJobAds"] = ::qpid::types::Variant(TotalJobAds);
    _map["TotalRemovedJobs"] = ::qpid::types::Variant(TotalRemovedJobs);
    _map["TotalRunningJobs"] = ::qpid::types::Variant(TotalRunningJobs);


    // Maintenance of hi-lo statistics


    }
}

void Scheduler::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("CondorPlatform")) != _map.end()) {
        CondorPlatform = (_i->second).getString();
    }
    if ((_i = _map.find("CondorVersion")) != _map.end()) {
        CondorVersion = (_i->second).getString();
    }
    if ((_i = _map.find("DaemonStartTime")) != _map.end()) {
        DaemonStartTime = _i->second;
    }
    if ((_i = _map.find("Pool")) != _map.end()) {
        Pool = (_i->second).getString();
    }
    if ((_i = _map.find("System")) != _map.end()) {
        System = (_i->second).getString();
    }
    if ((_i = _map.find("JobQueueBirthdate")) != _map.end()) {
        JobQueueBirthdate = _i->second;
    }
    if ((_i = _map.find("MaxJobsRunning")) != _map.end()) {
        MaxJobsRunning = _i->second;
    }
    if ((_i = _map.find("Machine")) != _map.end()) {
        Machine = (_i->second).getString();
    }
    if ((_i = _map.find("MyAddress")) != _map.end()) {
        MyAddress = (_i->second).getString();
    }
    if ((_i = _map.find("Name")) != _map.end()) {
        Name = (_i->second).getString();
    }

}

void Scheduler::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "echo") {
        ArgsGridMethodsEcho ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("sequence")) != inMap.end()) {
            ioArgs.io_sequence = _i->second;
        }
        if ((_i = inMap.find("body")) != inMap.end()) {
            ioArgs.io_body = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_ECHO, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["sequence"] = ::qpid::types::Variant(ioArgs.io_sequence);
        outMap["body"] = ::qpid::types::Variant(ioArgs.io_body);
        return;
    }

    if (methodName == "SubmitJob") {
        ArgsSchedulerSubmitJob ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Ad")) != inMap.end()) {
            ioArgs.i_Ad = (_i->second).asMap();
        }
        status = coreObject->ManagementMethod (METHOD_SUBMITJOB, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Id"] = ::qpid::types::Variant(ioArgs.o_Id);
        return;
    }

    if (methodName == "SetJobAttribute") {
        ArgsSchedulerSetJobAttribute ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Id")) != inMap.end()) {
            ioArgs.i_Id = (_i->second).getString();
        }
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("Value")) != inMap.end()) {
            ioArgs.i_Value = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_SETJOBATTRIBUTE, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "HoldJob") {
        ArgsSchedulerHoldJob ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Id")) != inMap.end()) {
            ioArgs.i_Id = (_i->second).getString();
        }
        if ((_i = inMap.find("Reason")) != inMap.end()) {
            ioArgs.i_Reason = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_HOLDJOB, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "ReleaseJob") {
        ArgsSchedulerReleaseJob ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Id")) != inMap.end()) {
            ioArgs.i_Id = (_i->second).getString();
        }
        if ((_i = inMap.find("Reason")) != inMap.end()) {
            ioArgs.i_Reason = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_RELEASEJOB, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "RemoveJob") {
        ArgsSchedulerRemoveJob ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Id")) != inMap.end()) {
            ioArgs.i_Id = (_i->second).getString();
        }
        if ((_i = inMap.find("Reason")) != inMap.end()) {
            ioArgs.i_Reason = (_i->second).getString();
        }
        status = coreObject->ManagementMethod (METHOD_REMOVEJOB, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
